package be.jeffcheasey88.peeratcode.parser.java.operations;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import be.jeffcheasey88.peeratcode.parser.java.CleanerPool;
import be.jeffcheasey88.peeratcode.parser.java.JavaElement;

public class MethodCallOperation extends JavaElement{
	
	private static Pattern PATTERN = Pattern.compile("^(\\s*([^\\^\\s]+\\^GENERIC_PARENTHESIS\\d+);).*$");

	private String value;
	
	public MethodCallOperation(){}
	
	@Override
	public int parse(String content, CleanerPool cleaner) throws Exception{
		System.out.println("method call "+cleaner);
		System.out.println("parse method "+content);
		content = cleaner.clean(content);
		
		Matcher matcher = PATTERN.matcher(content);
		matcher.matches();
		System.out.println("method call "+content);
		
		this.value = cleaner.unzip(matcher.group(2), (s,p) -> s);
		
		return cleaner.unzip(matcher.group(1), (s,p) -> s).length();
	}

	@Override
	public void show(int tab){
		String start = "";
		for(int i = 0; i < tab; i++) start+="\t";
		System.out.println(start+value+";");
	}
	
	
}
